#!/usr/bin/python
# coding: utf-8
bv = [{'value': '1', 'label': 'Contractuel', 'business_value' :'20' },
      {'value': '2', 'label': 'Support niv 1 + CP', 'business_value' :'0' },
      {'value': '3', 'label': 'Commercial','business_value' :'0' },
      {'value': '4', 'label': 'Utilisateur pro','business_value' :'0' },
      {'value': '5', 'label': 'Usager citoyen' ,'business_value' :'0' },
      {'value': '6', 'label': 'Communautaire','business_value' :'20' },
      {'value': '7', 'label': 'Prestation possible','business_value' :'0' },
      {'value': '8', 'label': 'Réglementaire','business_value' :'50' },
      {'value': '9', 'label': 'Innovation ','business_value' :'10' }]



from redminelib import Redmine
import json


redmine = Redmine('https://forge.afi-sa.net/', key="")
#project = redmine.project.get('opac3')

def display_business_possible_values():
    print(redmine.custom_field.get(81).possible_values) 

def get_value_from_bv(cf):
    sum = 0
    for values in cf.value:
        for field in bv:
            if field.get('value') == values:
                sum=sum + int(field.get('business_value'))
    return sum

def order_issue_by_score(): 
    result = redmine.issue.filter(project_id='opac3', status_id='1,2,23,24,4')[1:1000]
    output = {}

    for issue in result:
        if not hasattr(issue, 'custom_fields') :
            continue
        for custom_field in issue.custom_fields:
            if (custom_field.id == 81) and custom_field.value:
                output[issue.id]=(issue.subject, get_value_from_bv(custom_field))

    sorted_data = sorted(output.items(), key=lambda x: x[1][1], reverse=True)
    for (title, score) in sorted_data: 
        print(f"Tix: {title}, Score: {score[1]}, {score[0]}")

def save_cf_in_issue(issue, custom_field_id, score):

    cf  = []
    for custom_field in issue.custom_fields:
        if custom_field.id == custom_field_id:
            custom_field.value = str(score)
        new_cf = {}
        new_cf['id']=str(custom_field.id)
        new_cf['value']=custom_field.value
        cf.append(new_cf)

    issue.custom_fields=cf
#    if (issue.id == 40962) :
    issue.save()

def erase():

    result = redmine.issue.filter(project_id='opac3', status_id='1')[1:1000]
    for issue in result:
        if not hasattr(issue, 'custom_fields') :
            continue

        for custom_field in issue.custom_fields:
            if (custom_field.id == 81) and custom_field.value:
                score = get_value_from_bv(custom_field)
                save_cf_in_issue(issue, 74,score)

    

    
while True:
    print("Menu:")
    print("1. View business values")
    print("2. Display")
    print("3. Update All Business Values on Forge")
    print("4. Display custom field")
    print("5. Exit")

    choice = input("Enter your choice (1-5): ")

    if choice == '1':
        for val in bv:
            print(f"{val[ 'label']}     : {val['business_value']}")

    elif choice == '2':
        order_issue_by_score()

    elif choice == '3':
        erase()

    elif choice == '4':
        display_business_possible_values()
        break

    elif choice == '5':
        break
    else:
        print("Invalid choice. Please enter a valid option.")
